<#assign hasSortBar = false />
<#if ctrl.getPSDEDataViewDataItems?? && ctrl.getPSDEDataViewDataItems()??>
  <#list ctrl.getPSDEDataViewDataItems() as dataItem>
    <#if dataItem.getPSAppDEField?? && dataItem.getPSAppDEField()?? && !dataItem.getPSAppDEField().isKeyField()>
      <#assign hasSortBar = true />
    </#if>
  </#list>
</#if>
<#if ctrl.isEnableGroup()>
.app-data-view-group {
  height: 100%;
  display: flex;
  .dataview-group-content {
    border: 1px solid #ddd;
    border-left: 0;
    .dataview-group-header {
      height: 36px;
      line-height: 36px;
      border-bottom: 1px solid #ddd;
      padding: 0 8px;
      .group-action {
        .group-action-item:nth-child(1) + .group-action-item {
          margin-top: 5px;
        }
      }
    }
    .dataview-group-item {
      margin: 8px 8px 0 8px;
      border: 1px solid #ddd;
      padding: 8px;
    }
    .dataview-group-item.is-select {
      border-color: #108cee;
    }
  }
  .dataview-group-content:nth-child(1) {
    border-left: 1px solid #ddd;
  }
}
<#else>
.app-data-view {
    height: 100%;
    overflow-y: auto;
    overflow-x: hidden;
    // 排序栏样式
    .bar-container{
      padding: 6px 8px;
      background-color: #F1F1F1;
      .ivu-row-flex.page-sort-bar{
        width: 100%;
        height: 30px;
        .ivu-col{
          user-select: none;
          text-align: center;
          display: flex;
          align-items: flex-end;
          padding-bottom: 4px;
          background-color: #FFF;
          border: 1px solid #CCC;
          margin-left: -1px;
          .sort-field-text{
            margin-left: 7px;
          }
          .caret-wrapper{
            width: 15px;
            display: inline-block;
            padding-bottom: 2px;
            .ivu-icon{
              display: block;
              line-height: 0.5;
              color: #c5c8ce;
            }
          }
        }
        // 悬浮样式
        .ivu-col:hover{
            border:1px solid #82bff7;
            position:relative;
            z-index:2;
            .sort-field-text{
              color: #82bff7;
            }
        }
        // 选中样式
        .sort-ascending, .sort-descending{
            border:1px solid #82bff7;
            position:relative;
            z-index:2;
          .sort-field-text{
              color:#82bff7;
              font-weight: 800;
          }
        }
        .sort-ascending .caret-wrapper .ivu-icon.ivu-icon-md-arrow-dropup,
        .sort-descending .caret-wrapper .ivu-icon.ivu-icon-md-arrow-dropdown{
            color: #82bff7;
        }
      }
    }
    .data-view-container {
<#if hasSortBar>
        height: calc(100% - 42px);
<#else>
        height: 100%;
</#if>
        align-content: start;
        .ivu-col{
          padding: 10px;
          .el-card__body{
            padding: 10px;
          }
        }
        .el-card{
          background-color: #f6f6f6;
          color: #666666;
          box-shadow: 0 2px 12px 0 #909399;
        }
        .single-card-data{
            height: 100%;
            width: 100%;
            cursor: pointer;
            border: 2px solid transparent;
            .single-card-default {
                .ivu-tooltip{
                    .ivu-tooltip-rel{
                        width: 150px;
                        white-space: nowrap;
                        text-overflow: ellipsis;
                        overflow: hidden;
                        text-align: left;
                        padding-left: 5px;
                        font-size: 18px;
                        font-weight: 800;
                    }
                }
            }
            .single-card-img {
                width: 150px;
                height: calc(100% - 32px);
            }
        }
        .isselected{
            border: 2px solid #82bff7;
            box-shadow: 5px 5px 12px 0 #82bff7;
            .ivu-tooltip{
                color: #82bff7;
                font-weight: 800;
            }
        }
        .single-card-data:hover{
            border: 2px solid #82bff7;
            box-shadow: 5px 5px 12px 0 #82bff7;
            .ivu-tooltip{
              color: #82bff7;
              font-weight: 800;
            }
        }
    }
    // 空值文本
    .app-data-empty {
<#if hasSortBar>
        height: calc(100% - 42px);
<#else>
        height: 100%;
</#if>
        color: #909399;
        display: flex;
        justify-content: center;
        align-items: center;
    }
}
</#if>
<#ibizinclude>
../@MACRO/CSS/DEFAULT.less.ftl
</#ibizinclude>